﻿----------------------------------------------
-- Config
----------------------------------------------

------CLASS CONSTANTS COLORS------
RAID_CLASS_COLORS = {
    ["HUNTER"] = { r = 0.67, g = 0.83, b = 0.45, colorStr = "ffabd473" },
    ["WARLOCK"] = { r = 0.58, g = 0.51, b = 0.79, colorStr = "ff9482c9" },
    ["PRIEST"] = { r = 1.0, g = 1.0, b = 1.0, colorStr = "ffffffff" },
    ["PALADIN"] = { r = 0.96, g = 0.55, b = 0.73, colorStr = "fff58cba" },
    ["MAGE"] = { r = 0.41, g = 0.8, b = 0.94, colorStr = "ff69ccf0" },
    ["ROGUE"] = { r = 1.0, g = 0.96, b = 0.41, colorStr = "fffff569" },
    ["DRUID"] = { r = 1.0, g = 0.49, b = 0.04, colorStr = "ffff7d0a" },
    ["SHAMAN"] = { r = 0.0, g = 0.44, b = 0.87, colorStr = "ff0070de" },
    ["WARRIOR"] = { r = 0.78, g = 0.61, b = 0.43, colorStr = "ffc79c6e" },
    ["DEATHKNIGHT"] = { r = 0.77, g = 0.12 , b = 0.23, colorStr = "ffc41f3b" },
    ["MONK"] = { r = 0.0, g = 1.00 , b = 0.59, colorStr = "ff00ff96" },
};

-- Minimap
scale = 1.05                   -- Scale
position = "TOPLEFT"        -- Initial Position

-- Borders
borders = false              -- Enables or disables the white border on the minimap. True/False
bordersize = 1             -- Size of Border

-- Quest 
qparent = Minimap           -- Use "Minimap" or "UIParent". Defines what frame the anchor position is relative to.
qanchor = "BOTTOMRIGHT"     -- Where to anchor on the qparent ^
qposition_x = 0             -- X Offset
qposition_y = 0           -- Y Offset
qheight = 300              -- Determines the height of the quest tracker

-----Player Class----
UnitPlayerClass, UnitPlayerClassStandard = UnitClass("player");
UnitColor = RAID_CLASS_COLORS[UnitPlayerClassStandard];

----------------------------------------------
-- Config End
----------------------------------------------
local backdrop = {
bgFile = 'Interface\\AddOns\\intminimap\\img\\border', 
edgeFile = 'Interface\\AddOns\\intminimap\\img\\border', 
edgeSize = bordersize, 
insets = {left = -bordersize, right = -bordersize, top = -bordersize, bottom = -bordersize}}

local font = "FONTS\\FRIZQT__.ttf"
local mailicon = "Interface\\AddOns\\intminimap\\img\\mail"

Minimap:SetMaskTexture('Interface\\Buttons\\WHITE8x8')
Minimap:SetScale(scale)
Minimap:SetFrameStrata("BACKGROUND")
Minimap:ClearAllPoints()
Minimap:SetPoint(position, UIParent, -25, -25)

Minimap:SetMovable(true)
Minimap:EnableMouse(true)
Minimap:RegisterForDrag("LeftButton","RightButton")
Minimap:SetScript("OnDragStart", function(self) if IsAltKeyDown() and IsShiftKeyDown() then self:StartMoving() end end)
Minimap:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
Minimap:SetUserPlaced(true)
SlashCmdList["RESETMINIMAP"] = function() 
    Minimap:SetUserPlaced(false)
    ReloadUI()
end

ObjectiveTrackerFrame:SetMovable(true)
ObjectiveTrackerFrame:EnableMouse(true)
ObjectiveTrackerFrame:RegisterForDrag("LeftButton","RightButton")
ObjectiveTrackerFrame:SetScript("OnDragStart", function(self) if IsAltKeyDown() and IsShiftKeyDown() then self:StartMoving() end end)
ObjectiveTrackerFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
ObjectiveTrackerFrame:SetUserPlaced(true)

SLASH_RESETMINIMAP1 = "/intmapreset"

----------------------------------------------
-- Border Color --
----------------------------------------------
if (borders == true) then
    Minimap:SetBackdrop(backdrop)
    Minimap:SetBackdropBorderColor(UnitColor.r,UnitColor.g,UnitColor.b)
    Minimap:SetBackdropColor(UnitColor.r,UnitColor.g,UnitColor.b)
end

----------------------------------
-- Hide Items
----------------------------------
MinimapBorder:Hide()
MinimapBorderTop:Hide()

MinimapZoomIn:Hide()
MinimapZoomOut:Hide()

MiniMapVoiceChatFrame:Hide()

GameTimeFrame:Hide()

MinimapZoneTextButton:Hide()

MiniMapTracking:Hide()

MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPRIGHT", Minimap, 3, 4)

MiniMapMailIcon:SetTexture(mailicon)
MiniMapMailBorder:Hide()

MinimapNorthTag:SetAlpha(0)

----------------------------------
-- Move Items
----------------------------------
ObjectiveTrackerFrame:ClearAllPoints()	
ObjectiveTrackerFrame.ClearAllPoints = function() end

ObjectiveTrackerFrame:SetPoint("TOPRIGHT", qparent, qanchor, qposition_x, qposition_y)
ObjectiveTrackerFrame.SetPoint = function() end
ObjectiveTrackerFrame:SetClampedToScreen(true)
ObjectiveTrackerFrame:SetHeight(qheight)

MiniMapWorldMapButton:Hide()

MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetParent(Minimap)
MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetParent(Minimap)
GuildInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint("BOTTOMLEFT", Minimap, 0, 0)

QueueStatusFrame:ClearAllPoints()
QueueStatusFrame:SetPoint("TOPLEFT", Minimap, "BOTTOMRIGHT")

----------------------------------
-------------- Time
----------------------------------
LoadAddOn('Blizzard_TimeManager')

local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
clockFrame:Hide()
clockTime:Hide()
clockTime:SetFont(font, 14)
    if(CalendarGetNumPendingInvites() > 0) then
		clockTime:SetTextColor(0, 1, 0)
	else
		clockTime:SetTextColor(1, 1, 1)
    end


----------HOVER FUNCTIONS------------

TimeManagerClockButton:SetPoint("CENTER", Minimap, "BOTTOM", -2, 10)
TimeManagerClockButton:EnableMouse(false)

Minimap:SetScript("OnEnter", function()
    clockTime:Show()
    UIFrameFadeIn(clockTime, 0.2, 0, 1)
end)
Minimap:SetScript("OnLeave", function()
    UIFrameFadeOut(clockTime, 0.2, 1, 0)
end)

Minimap:EnableMouseWheel(true)
Minimap:SetScript('OnMouseWheel', function(self, delta)
    if delta > 0 then
        Minimap_ZoomIn()
    else
        Minimap_ZoomOut() 
    end
end)

Minimap:SetScript("OnMouseUp", function(self, button)
    if button == "RightButton" then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (Minimap:GetWidth() * 0.7), -3)
    elseif (button == "MiddleButton") then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)


function GetMinimapShape() return 'SQUARE' end
