
local number = oUF_Nivaya.number

local classification = {
	["worldboss"] = "%s",
	["rareelite"] = "%s+ Rar",
	["elite"] = " %s+",
	["rare"] = " %s Rar",
	["normal"] = "%s",
	["trivial"] = "%s",
    ["minus"] = "%s"
}

-------------------------------------------------------
-- Short Status Tag
oUF.Tags.Methods["nivStatus_offline+dead"] = function(u)
    local t = _TAGS['offline'](u) or _TAGS['dead'](u)
    if t then return (t == 'Offline') and 'off' or 'dead' end
end

-------------------------------------------------------
-- Player HP
oUF.Tags.Methods["nivHP_player"] = function(u)
    local t = _TAGS['offline'](u) or _TAGS['dead'](u)
    if t then return t end

    t = _TAGS["missinghp"](u)
    if t then return '|cffff8080-' .. number(t) .. '|r |cff0090ff/|r ' .. _TAGS['perhp'](u) ..'%' end

    return number(_TAGS["curhp"](u))
end

-------------------------------------------------------
-- HP for Party-/Raidframes
oUF.Tags.Methods["nivHP_party+raid"] = function(u)
    local t = _TAGS['nivStatus_offline+dead'](u)
    if t then return t end

    t = _TAGS["missinghp"](u)
    if t then return '|cffff8080-' .. number(t) .. '|r' end

    return number(_TAGS["curhp"](u))
end

-------------------------------------------------------
-- HP for target, focus, ToT, focus target and ToToT
oUF.Tags.Methods["nivHP_target+focus+tot"] = function(u)
    local t = _TAGS['offline'](u) or _TAGS['dead'](u)
    if t then return t end

    t = _TAGS["missinghp"](u)
    if t then return number(_TAGS['curhp'](u)) .. ' (' .. _TAGS['perhp'](u) .. '%)' end

    return number(_TAGS["curhp"](u))
end

-------------------------------------------------------
-- Pet HP
oUF.Tags.Methods["nivHP_pet"] = function(u)
    local t = _TAGS['offline'](u) or _TAGS['dead'](u)
    if t then return t end

    return number(_TAGS["curhp"](u))
end

-------------------------------------------------------
-- Power tag (Mana, Focus, Rage, ...)
oUF.Tags.Methods["nivPP"] = function(u)
    local t = _TAGS["curpp"](u)
    if (t ~= 0) then return '|cff8080ff' .. number(t) .. '|r' end
end

-------------------------------------------------------
-- custom level and classification tag
oUF.Tags.Methods["nivLevel"] = function(u)
    return format(classification[UnitClassification(u)], _TAGS['level'](u))
end

-------------------------------------------------------
-- Name tag for player and target frames
oUF.Tags.Methods["nivName_player+target"] = function(u)
    local name = oUF_Nivaya:ShortName(_TAGS["name"](u), 25, true)
    return _TAGS["nivLevel"](u) .. ' |cffFFFFFF' .. (name or u) .. '|r'
end

-------------------------------------------------------
-- Name tag for standard frames
oUF.Tags.Methods["nivName_std"] = function(u)
    return '|cffFFFFFF' .. oUF_Nivaya:ShortName(_TAGS["name"](u), 25, true) .. '|r'
end

-------------------------------------------------------
-- Name tag for Party-/Raidframes
oUF.Tags.Methods["nivName_prAlways"] = function(u)
    return oUF_Nivaya:ShortName(_TAGS["name"](u), nivDB.pr_namelen)
end

oUF.Tags.Methods["nivName_prMinimal"] = function(u)
    local t = _TAGS["nivStatus_offline+dead"](u)
    if not t then return _TAGS["nivName_prAlways"](u) end
end

-------------------------------------------------------
-- Tag Events
oUF.Tags.Events['nivStatus_offline+dead'] = "UNIT_HEALTH UNIT_CONNECTION"
oUF.Tags.Events['nivHP_player'] = "UNIT_HEALTH"
oUF.Tags.Events['nivHP_party+raid'] = "UNIT_HEALTH"
oUF.Tags.Events['nivHP_target+focus+tot'] = "UNIT_HEALTH"
oUF.Tags.Events['nivHP_pet'] = "UNIT_HEALTH"
oUF.Tags.Events['nivPP'] = "UNIT_POWER"
oUF.Tags.Events['nivLevel'] = "UNIT_LEVEL PLAYER_LEVEL_UP UNIT_CLASSIFICATION_CHANGED"
oUF.Tags.Events['nivName_player+target'] = "UNIT_NAME_UPDATE PLAYER_LEVEL_UP UNIT_HEALTH UNIT_MAXHEALTH UNIT_CONNECTION"
oUF.Tags.Events['nivName_std'] = "UNIT_NAME_UPDATE UNIT_HEALTH UNIT_MAXHEALTH UNIT_CONNECTION"
oUF.Tags.Events['nivName_prMinimal'] = "UNIT_NAME_UPDATE UNIT_HEALTH UNIT_MAXHEALTH UNIT_CONNECTION"
oUF.Tags.Events['nivName_prAlways'] = "UNIT_NAME_UPDATE UNIT_HEALTH UNIT_MAXHEALTH UNIT_CONNECTION"